Subject: Re: Export from bzr / Import to git results in a deleted file re-appearing

From: Andreas Schwab <[email-masked]>
Date: Fri, 13 Jul 2012 15:39:50 +0200

Jeff King <[email-masked]> writes:

> On Fri, Jul 13, 2012 at 11:04:21AM +0200, Andreas Schwab wrote:
>
>> > If you run only the bzr half of your command and inspect the output, you
>> > will see that the file in question is mentioned twice.  Once in a commit
>> > on "refs/heads/master" that renames into it from another file:
>> >
>> >   R freeplane_plugin_spreadsheet/src/org/freeplane/plugin/spreadsheet/SpreadSheetUtils.java
>> >     freeplane_plugin_formula/src/org/freeplane/plugin/formula/SpreadSheetUtils.java
>> 
>> That same revision also removes it, but is uses the original name for
>> the deletion (the bzr revision actually renames the containing
>> directory).  That's probably what confuses git fast-import.
>> [...]
>> The output contains these lines:
>> 
>> R a/b b/b
>> D a/b
>> 
>> Changing the second line to D b/b fixes the bug.
>
> Yeah, I agree that is problematic. But I do not think it is a
> fast-import bug, but rather bogus output generated by bzr fast-export (I
> am not clear from what you wrote above if you are considering it a bug
> that fast-import is confused). It seems nonsensical to mention a file
> both as a rename source and as deleted in the same revision, and
> certainly I would not expect an importer to deduce a link between the
> second line and b/b.

IMHO fast-import should raise an error in this case, like it does when
you switch the lines.

Andreas.

-- 
Andreas Schwab, [email-masked]
GPG Key fingerprint = 58CA 54C7 6D53 942B 1756  01D3 44D5 214B 8276 4ED5
"And now for something completely different."